#! /usr/bin/env python

from BeautifulSoup import BeautifulSoup
import re, sys

try: 
	page = ""
	for line in sys.stdin:
		page += line
except:
	print "Input to stdin caused error:" , sys.exc_info()[0]

try:
	soup = BeautifulSoup(page)

	allowableTags = set(["html", "head", "body", "div", "span", "title", "link", "meta", "p", "h1", "h2", "h3", "h4", "h5", "h6", "strong", "em", "abbr", "acronym", "address", "bdo", "blockquote", "cite", "q", "code", "dfn", "kbd", "pre", "samp", "var", "br", "a", "base", "img", "ul", "ol", "li", "dl", "dt", "dd", "table", "tr", "td", "th", "tbody", "thead", "tfoot", "col", "colgroup", "caption", "b", "i", "tt", "sub", "sup", "big", "small", "hr"])

	allowableAttrs = set(["class", "dir", "id", "lang", "style", "title", "xml:lang", "href", "name", "content", "align", "valign" "width", "height", "src", "border", "alt", "rel"])

	urlRegex = "(https?\://(www2?\.)?([a-zA-Z]+\.)+(com|net|edu|org|gov))?[a-zA-Z0-9\.\-/\_]*(\#[a-zA-Z0-9]+)?"
	imgRegex = "(https?\://(www2?\.)?([a-zA-Z]+\.)+(com|net|edu|org|gov))?[a-zA-Z0-9\.\-/\_]*(\#[a-zA-Z0-9]+)?(\.(ico|jpg|png|tiff|png|raw|gif|bmp))"

	###########

	allTags = soup.findAll(True)
	allTagNames = [tag.name for tag in allTags]

	#filter out tags
	for tagName in allTagNames:
		if tagName not in allowableTags:
		  badTags = soup.findAll(tagName)
		  for badTag in badTags:
		    badTag.extract()
		    
	#filter out attributes
	allTags = soup.findAll(True)
	for tag in allTags:
		for (attr, val) in tag.attrs:
			if attr not in allowableAttrs:
				del(tag[attr])
			elif attr == "href":
				addr = str(val)
				m = re.match(urlRegex, addr)
				if m == None or (m != None and m.group(0) != addr):
					tag[attr] = "this url format is not allowed"
			elif attr == "src":
				addr = str(val)
				m = re.match(imgRegex, addr)
				if m == None or (m != None and m.group(0) != addr):
					tag[attr] = "this src url format is not allowed"
						  
	print soup.prettify()
except:
	print "Input with parsing/filtering caused error:" , sys.exc_info()[0]
